=== PKGBUILD ===
# Maintainer: Antonio Rojas <arojas@archlinux.org>

pkgname=telegram-qt
pkgver=0.1.0
pkgrel=4
pkgdesc="Qt bindings for the Telegram protocol"
arch=(x86_64)
url="https://github.com/Kaffeine/telegram-qt"
license=(GPL)
depends=(qt5-base)
makedepends=(cmake)
source=("https://github.com/Kaffeine/telegram-qt/archive/$pkgname-$pkgver.tar.gz")
md5sums=('fcc498a8c2655ee0d9877b1784e76cec')

prepare() {
  mkdir -p build
}

build() {
  cd build
  cmake ../$pkgname-$pkgname-$pkgver \
    -DCMAKE_INSTALL_PREFIX=/usr \
    -DCMAKE_INSTALL_LIBDIR=lib \
    -DCMAKE_BUILD_TYPE=Release
  make
}

package() {
  cd build
  make DESTDIR="$pkgdir" install
}
